<?php
/**
 * Created by PhpStorm.
 * User: lzs
 * Date: 2018/5/21
 * Time: 18:13
 *
 */

namespace Home\Controller;

use Common\Controller\HomeController;
use EB\Api\EpowerBasic;
use Home\Service\CardService;
use Home\Service\EnterpriseEmailService;
use Home\Service\PricesService;

class EnterpriseEmailController extends HomeController{
    private $default_product_id = 1;

    public function _initialize()
    {
        parent::_initialize();
        $this->base('etpemail');
    }

    public function buy()
    {
        $is_card = 0;
        if (C('product.card_etpemail')==='yes' && C('product.card')==='1')
            $is_card = 1;
        $userid = session('userid');
        $card_list = [];
        if ($userid) {
            $user = M('users')->where(['id'=>$userid])->find();
            // 可用的优惠券
            $card_list = CardService::GetCards('etpemail', $this->default_product_id, $user['id'], $user['groupid']);
        }
        
        $helpclid = M('help_class')->where(['enName'=>'etpemail'])->getField('id');
        $helps = M('help')->field('id,classid,title')->where(array('classID'=>$helpclid))->order('id desc')->limit(9)->select();



        $this->assign('is_card',$is_card);
        $this->assign('card_list',$card_list);
        $this->assign('helps',$helps);
        $this->display();
    }

    /**
     * 开通邮箱
     */
    public function addAgentDomain(){
        if (!IS_POST || !IS_AJAX){
            $this->error('非法访问',U('/'));
        }

        $userid = session('userid');
        if (empty($userid)){
            $this->ajaxCode(403,"用户未登录");
        }
        $user = M('users')->where(['id'=>$userid])->find();

        $input = I('post.',array());

        if ($input['checked'] !== '1'){
            $this->ajaxCode(400,"请阅读并勾选服务条款");
        }

        $etpemail = new EnterpriseEmailService();

        // 验证数据有效性
        $input['product_id'] = $this->default_product_id;

        if (!$etpemail->addDataCheck($input)){
//            $this->ajaxError($etpemail->get_error_no().':'.$etpemail->get_error_msg());
            $this->ajaxCode(400,$etpemail->get_error_msg());
        }

        $data = [
            'customer_name' => empty($user['authname']) ? $user['name'] : $user['authname'],
            'domain_name' => $input['domain_name'],
//            'product_id' => intval($input['product_id']),
            'product_id' => $this->default_product_id,
            'max_user' => intval($input['max_user']),
            'month_num' => intval($input['month_num']),
            'customer_id' => $user['id'],
            'customer_email' => $input['customer_email'],
            'customer_mobile' => $input['customer_mobile'],
            'customer_linkman' => $input['customer_linkman'],
            'corp_name' => $input['corp_name'],
            'sell_num' => $input['sell_num'],
            'card_code' => $input['card_code']
        ];

        // 开通
        $res = $etpemail->create($user,$data);
        if (!$res){
            // 开通失败
//            $this->ajaxError($etpemail->get_error_no().':'.$etpemail->get_error_msg());
            $this->ajaxCode(400,$etpemail->get_error_msg());
        }

        // 初始化邮箱登录页面信息
//        $this->initLoginPage($res['domain_name'],$res['domain_id'],$user);

        $this->ajaxCode(200,'邮箱购买成功');
    }

    /**
     * 获取产品价格
     */
    public function getPrice()
    {
        if (!IS_GET || !IS_AJAX){
            $this->error('非法访问',U('/'));
        }

        $userid = session('userid');
        if (!empty($userid)){
            $user = M('users')->where(['id'=>$userid])->find();
        }

        $operation = I('get.type',false);
        $operations = ['create','renew','expand'];
        if (!$operation || !in_array($operation,$operations)){
            $this->ajaxError("类型异常");
        }

        if ($operation == 'create' || $operation == 'renew') {
            $month_num = I('get.month_num', 0, 'intval');
            $years = $month_num / 12;
            if ($operation == 'create' && ($month_num < 12 || $month_num > 60)){
                $this->ajaxError("购买年限异常");
            }
        }

        if ($operation == 'create' || $operation == 'expand') {
            $max_user = I('get.max_user', 0, 'intval');
            if ($max_user < 3 || $max_user > 1000) {
                $this->ajaxError("购买用户数范围为3~1000");
            }
        }

        if ($operation === 'create'){
            /*$is_card = false;
            $card_code = I('get.card_code','');
            if (C('product.card_etpemail')==='yes' && C('product.card')==='1'){
                $is_card = true;
            }*/

            if (!empty($user)){
                $money = PricesService::getMoney(PricesService::PDTYPES_ETPEMAIL, $this->default_product_id, $user['id'], $user['groupid'], $years, 0);
                $money = $money*$max_user;
                /*if ($is_card && $card_code != 'none'){
                    $card_money = CardService::CheckCard('etpemail',$this->default_product_id,$user['id'],$user['groupid'],$card_code,$month_num,$money);
                }*/
            }else{
                $money = PricesService::getLevelMoney(PricesService::PDTYPES_ETPEMAIL,$this->default_product_id,0,$years,0);
                $money = $money*$max_user;
//                $card_money = 0;
            }
            if ($money==-1) {
                $this->ajaxError("获取价格失败");
            }
//            $money = $money-$card_money;

            $this->ajaxOK('获取价格成功',['price'=>$money]);
        }

        $domain_id = I('get.domain_id','');
        $product = M('enterprise_email')->where(['domain_id'=>$domain_id,'status'=>2])->find();
        if (empty($product)){
            $this->ajaxError("邮箱异常");
        }

        if ($operation === 'renew'){
            if (!empty($user)){
                $money = PricesService::getMoney(PricesService::PDTYPES_ETPEMAIL, $product['product_id'], $user['id'], $user['groupid'], $years, 1);
            }else{
                $money = PricesService::getLevelMoney(PricesService::PDTYPES_ETPEMAIL,$this->default_product_id,0,$years,1);
            }
            if ($money==-1) {
                $this->ajaxError("获取价格失败");
            }
            $money = $money*$product['max_user'];

            $this->ajaxOK('获取价格成功',['price'=>$money]);
        }

        if ($operation === 'expand'){
            if ($max_user <= $product['max_user']){
                $this->ajaxError("扩容用户总数必须大于原有用户总数");
            }

            $now_date = date('Y-m-d H:i:s',time());
            $expire_date = $product['expire_time'];
            $month_diff = abs(getMonthNum($expire_date,$now_date));
            $years_diff = bcdiv($month_diff, 12, 3);
            $user_diff = $max_user-$product['max_user'];
            if (!empty($user)){
                $money = PricesService::getMoney(PricesService::PDTYPES_ETPEMAIL, $product['product_id'], $user['id'], $user['groupid'], $years_diff, 0);
            }else{
                $money = PricesService::getLevelMoney(PricesService::PDTYPES_ETPEMAIL,$this->default_product_id,0,$years_diff,0);
            }
            if ($money==-1) {
                $this->ajaxError("获取价格失败");
            }
            $money = bcmul($money, $user_diff, 2);

            $this->ajaxOK('获取价格成功',['price'=>$money]);
        }

    }

    /**
     * 获取当前用户的相关信息
     */
    public function getUserInfo()
    {
        if (IS_AJAX) {
            $userid = session('userid');
            if (empty($userid)) {
                $this->ajaxError( "用户未登录");
            }

            $user_info = M('users')->where(['id' => $userid])->find();

            $data['customer_linkman'] = $user_info['name'];
            $data['customer_email'] = $user_info['email'];
            $data['customer_mobile'] = $user_info['mobile'];
            $data['corp_name'] = $user_info['authname'];
            $this->ajaxOK('success', $data);
        }

    }

    /**
     * 初始化登录界面信息
     * @param $dmain_name, 邮箱域名
     * @return
     */
    private function initLoginPage($domain_name, $domain_id, $user)
    {
        /*$userid = session('userid');
        if (empty($userid)){
            $this->ajaxError("用户未登录");
        }*/

        /*$domain_name = 'snake.com';
        $domain_id = '5b34309e8129b';
        $user = M('users')->where(['id'=>110001])->find();*/
        $copyright = C('basic.copyright');
        $lp_data = [
            'changeCopyRight' => true,
            'changeLogo' => true,
            'changeLoginPhoto' => true,
            'changeMailLogo' => true,
            'domain_name' => $domain_name,
            'domain_id' => $domain_id,
            'copyright' => $copyright
        ];
        $etpemail = new EnterpriseEmailService();
        if (!$etpemail->loginPageDataCheck($lp_data)){
            // 数据验证不通过
            return false;
        }

        $res = $etpemail->loginPageChange($user,$lp_data);
        if (!$res){
            // 修改登录界面信息失败
            return false;
        }
        return true;
    }

}